#!/usr/bin/python
import os,string,math,random,time,pickle,sys,thread
from pygame.locals import *
from random import random
from thread import *
from tuxmathscrabble.myutil import *
from GridCell import *
from Carousel import *
try:
	for sitepkgdir in sys.path:
		if sitepkgdir[-13:]=='site-packages':break
except:pass

class Actor(pygame.sprite.Sprite):
	#dinosaurs,trees and volcanos
	def __init__(self,indir,w_scene,h_scene,x,y,z,smk,carousel,parent_actor):# "smk"==specific_maneuver_key
		
		pygame.sprite.Sprite.__init__(self)
		
		self.indir=indir
		self.carousel=carousel
		
		self.parent_actor=parent_actor
		
		infile=os.path.join(indir,'config')
		inf=open(infile)
		self.config=eval(inf.read())
		inf.close()
		
		self.actor_name=self.config['preferences']['name']
		#print self.actor_name
		
		self.tlcxy=[0,0]
		
		prefs=self.config['preferences']
		try:self.tlcxy[0]=prefs['x']+int(random()*prefs['dx'])
		except:self.tlcxy[0]=int(random()*w_scene)
		try:self.tlcxy[1]=prefs['y']+int(random()*prefs['dy'])
		except:self.tlcxy[1]=int(random()*h_scene)
		if prefs['z']:self.z=prefs['z']
		else:self.z=int(random()*10)
		
		if x:self.tlcxy[0]=x
		if y:self.tlcxy[1]=y
		if z:self.z=z

		#do try/except because not all configs updated yet.
		try:self.AMLAYER=self.config['preferences']['AMLAYER']
		except:self.AMLAYER=False
		try:self.ENVOBJECT=self.config['preferences']['ENVOBJECT']
		except:self.ENVOBJECT=False
		
		self.maneuvers=[]#list of dictionaries w/surfaces and offsets lists
		for key in self.config['maneuvers'].keys():
			
			if (smk != None) and (smk != key):continue	#i.e. it's a bkg but wrong layer for this actor (this is necessary! see config's)
			
			if self.AMLAYER:
				if not self.ENVOBJECT:
					self.tlcxy[0]=0
					self.tlcxy[1]=0
				#print key,self.z
				self.z=self.config['maneuvers'][key][0]['z']
			
			
			maneuver={
				'key':key,
				'surfaces':[],
				'dx':[],
				'dy':[],
			}
			for idx in range(len(self.config['maneuvers'][key])):
				
				fname=self.config['maneuvers'][key][idx]['img']
				self.imgfile=os.path.join(indir,fname)
				#print self.imgfile
				#surf,rect=load_image(self.imgfile)
				surf=self.carousel.load_once(self.imgfile)
				if self.z==999:surf=pygame.transform.scale(surf,(w_scene,h_scene))
				
				#http://archives.seul.org/pygame/users/May-2001/msg00055.html
				if self.actor_name[0:5]=='smoke':
					surf.set_alpha(25,RLEACCEL)
					colorkey=0,0,255
					surf.set_colorkey(colorkey)
    				
					
				if self.actor_name[0:4]=='lava':
					colorkey=0,0,0
					surf.set_colorkey(colorkey)

				maneuver['surfaces'].append(surf)
				dx=eval(self.config['maneuvers'][key][idx]['dx'])
				dy=eval(self.config['maneuvers'][key][idx]['dy'])
				maneuver['dx'].append(dx)
				maneuver['dy'].append(dy)
				
				#again: try/except b/c only implemented in smoke envobjects
				try:maneuver['x']=self.config['maneuvers'][key][idx]['x']
				except Exception,e:pass#print e
				try:maneuver['y']=self.config['maneuvers'][key][idx]['y']
				except Exception,e:pass#print e
				
				maneuver['z']=eval(self.config['maneuvers'][key][idx]['dy'])
				
				
			self.maneuvers.append(maneuver)
		
		self.maneuver_idx=int(random()*len(self.maneuvers))
		self.seq_idx=0
		#print self.z
		
	def render(self,scene,centerline,dx):
			
		
		self.seq_idx=self.seq_idx+1
		if self.seq_idx>=len(self.maneuvers[self.maneuver_idx]['dx']):
			rand=random()
			self.maneuver_idx=int(rand*len(self.maneuvers))
			self.seq_idx=0
		
		
		if self.ENVOBJECT:
			maneuver=self.maneuvers[self.maneuver_idx]
			dx=maneuver['dx'][self.seq_idx]
			
			self.tlcxy[0]=self.parent_actor.tlcxy[0]+maneuver['x']#starting to implement here for mult image sizes.(little plumes)
			self.tlcxy[1]=self.parent_actor.tlcxy[1]+maneuver['y']
			
			vpw=scene.get_size()[0]#viewport_width (ie window, but could be smaller)
			img=maneuver['surfaces'][self.seq_idx]
			img_w=img.get_size()[0]
			img_h=img.get_size()[1]
			
			try:scene.blit(img,(self.tlcxy[0]-self.carousel.bgsize,self.tlcxy[1]))
			except Exception,e:print e,'1'
			try:scene.blit(img,(self.tlcxy[0],self.tlcxy[1]))
			except Exception,e:print e,'2'
			try:scene.blit(img,(self.tlcxy[0]+self.carousel.bgsize,self.tlcxy[1]))
			except Exception,e:print e,'3'
				
			
		elif self.AMLAYER==False:
			maneuver=self.maneuvers[self.maneuver_idx]
			
			self.tlcxy[0]=self.tlcxy[0]+(dx+maneuver['dx'][self.seq_idx])*(self.z/1.+1)# +dx of layer!
			self.tlcxy[1]=self.tlcxy[1]+maneuver['dy'][self.seq_idx]
			
			vpw=scene.get_size()[0]#viewport_width (ie window, but could be smaller)
			
			img=maneuver['surfaces'][self.seq_idx]
			img_w=img.get_size()[0]
			img_h=img.get_size()[1]
			
			#####
			#NEED: want to blit this relative to parent_actor.tlcxy[0]
			#####
			try:scene.blit(img,(self.tlcxy[0]-self.carousel.bgsize,self.tlcxy[1]))
			except Exception,e:print e,'1'
			try:scene.blit(img,(self.tlcxy[0],self.tlcxy[1]))
			except Exception,e:print e,'2'
			try:scene.blit(img,(self.tlcxy[0]+self.carousel.bgsize,self.tlcxy[1]))
			except Exception,e:print e,'3'
	
			if self.tlcxy[0]<-img_w:self.tlcxy[0]=vpw+img_w
			elif self.tlcxy[0] > vpw+img_w:self.tlcxy[0]=-img_w
			
			scene.blit(img,(self.tlcxy[0],self.tlcxy[1]))
			
			
		elif self.AMLAYER==True:
			#print self.config['preferences']['name'],'AMLAYER'
			
			maneuver=self.maneuvers[self.maneuver_idx]
			img=maneuver['surfaces'][self.seq_idx]
			img_w=img.get_size()[0]
			img_h=img.get_size()[1]

			if self.z==999:#FRAME
				scene.blit(img,(self.tlcxy[0],self.tlcxy[1]))
				return
			
			self.tlcxy[0]=self.tlcxy[0]+dx*(self.z/1.+1)#the 2 in the denominator reduces relative speed btw bkg layers.;dx scales.
			self.tlcxy[1]=self.tlcxy[1]+maneuver['dy'][self.seq_idx]
			vpw=scene.get_size()[0]#viewport_width (ie window, but could be smaller)
	
			tlc=self.tlcxy[0]
			c=img_w
			trc=tlc+img_w
			
			if trc<0:# and dx<0
				self.tlcxy[0]=img_w
				tlc=self.tlcxy[0]
				trc=tlc+img_w
			
			elif tlc>vpw:# and dx>0
				self.tlcxy[0]=self.tlcxy[0]-img_w
				tlc=self.tlcxy[0]
				trc=tlc+img_w
			
			scene.blit(img,(tlc,self.tlcxy[1]))
			scene.blit(img,(tlc-img_w,self.tlcxy[1]))
			scene.blit(img,(tlc+img_w,self.tlcxy[1]))
			
			"""
			#pygame.draw.aaline(Surface, color, startpos, endpos, blend=1) -> Rect
			try:#THE MAIN REFERENCE LINE
				if self.maneuvers[0]['key']=='layer_0':
					dr=pygame.draw.aaline(scene,(244,0,0),(self.tlcxy[0],0),(self.tlcxy[0],img_h),0)
			except Exception,e:print e
			"""
		
		
