import os,time
import pygame
from pygame.locals import *
from tuxmathscrabble.Environment import *


class Attempt:
	def __init__(self,main,m,name):
		self.questions=[]
		self.question_surface=None
		self.submission_surface=None
		self.current_question=None
		self.SHIFT_DOWN=0
		self.font=None#pygame.font.Font(self.self.config['default_font'],100)
		self.results_font=None#pygame.font.Font(self.self.config['default_font'],40)#make propto setlen
		self.questions=[]
		self.config=None
		self.infname=None
		
		self.main=main
		self.m=m
		self.name=name
		
		#load the user config
		user_infname=os.path.join(userdir,name,'config')
		self.user_oufname=user_infname
		inf=open(user_infname)
		self.user_config=eval(inf.read())
		
		
		infname=os.path.join('tuxmathscrabble','ProblemSet',m['ProblemSet'],'config')
		self.oufname=infname
		inf=open(infname)
		self.config=eval(inf.read())
		inf.close()
		#print 'config'
		#print self.config
		
		
	def start(self):
		
		#if m.has_key('font'):
		#elif self.config.has_key('font'):
		m=self.m
		main=self.main
		if m['type']=='raw':
			
			for idx in range(len(self.config['problems'])):
				question={
					'question':self.config['problems'][idx][0],
					'user_answer':None,
					'correct_answer':self.config['problems'][idx][1]
				}
				self.current_question=question

				fgcolor=(255,255,255)
				if m.has_key('fgcolor'):fgcolor=m['fgcolor']
				elif self.config.has_key('fgcolor'):fgcolor=self.config['fgcolor']
				
				bgcolor=(0,0,0)
				if m.has_key('bgcolor'):bgcolor=m['bgcolor']
				elif self.config.has_key('bgcolor'):bgcolor=self.config['bgcolor']
				
				self.question_surface=main.submission_font.render(question['question'],1,fgcolor,bgcolor)
				question['user_answer']=self.handle_user_input(main,bgcolor,fgcolor)
				self.questions.append(question)
				
			results=self.compute_score()	
			self.display_results(results,main,fgcolor,bgcolor)
			self.update_user_config(m,results)
			
			
		elif m['type']=='slide':
			#print 'slideshow',m['slides']
			pass
			
		elif m['type']=='autogen':
			#print 'autogen'
			pass
			
		#print self.config['problems']
		
		
		return 1
	
	def update_user_config(self,m,results):
		self.user_config['history'].append(results)
		self.save_user_config()
	
		
	def save_user_config(self):
		ouf=open(self.user_oufname,'w')
		ouf.write("{\n")
		for key in self.user_config.keys():
			line="\t'%s':%s,\n"%(key,`config[key]`)
			ouf.write(line)
		ouf.write("}")
		ouf.close()

	def save_config(self):
		ouf=open(self.oufname,'w')
		ouf.write("{\n")
		for key in self.config.keys():
			line="\t'%s':%s,\n"%(key,`config[key]`)
			ouf.write(line)
		ouf.write("}")
		ouf.close()
		
	
	def compute_score(self):
		correct=incorrect=0
		for q in self.questions:
			if q['user_answer']==q['correct_answer']:correct+=1
			else:incorrect+=1
		return((correct,incorrect))
	
	def display_results(self,results,main,fg,bg):
		total=results[0]+results[1]
		if results[0]==total:
			msg="Congratulations! Score=%d/%d"%(results[0],total)
		else:
			msg="No Pass! Score=%d/%d"%(results[1],total)
		
		
		msg_surface=main.submission_font.render(msg,1,fg,bg)	
			
		rendered_size=main.submission_font.size(msg)
		x_lhs=main.W/2-rendered_size[0]/2
		y_top=rendered_size[1]/2
		
		main.screen.fill(bg)
		main.screen.blit(msg_surface,(x_lhs,y_top))
		
		#Now for the transcript:
		for idx in range(len(self.questions)):
			question=self.questions[idx]['question']
			correct_answer=self.questions[idx]['correct_answer']
			user_answer=self.questions[idx]['user_answer']
			msg="%s %s %s "%(question,correct_answer,user_answer)
			
			if user_answer==correct_answer:msg_surface=main.results_font.render(msg,1,fg,bg)	
			else:msg_surface=main.results_font.render(msg,1,(255,0,0),bg)
			
			y_top=y_top+rendered_size[1]
			rendered_size=main.results_font.size(msg)
			x_lhs=main.W/2-rendered_size[0]/2
			
			main.screen.blit(msg_surface,(x_lhs,y_top))
			
		main.flip()
		while True:
			if pygame.event.wait().type==KEYDOWN:break
		

	def handle_user_input(self,main,bg,fg):			
		submission=""
		rendered_size=main.submission_font.size(self.current_question['question'])
		x_lhs=main.W/2-rendered_size[0]/2
		y_top=main.H/2-rendered_size[1]/2
		while 1:
			for e in pygame.event.get([KEYDOWN]):
				#print chr(e.key)
				if e.key==K_ESCAPE or e.key==13:return submission
				elif e.key==self.config['helpkey']:print 'launch help module'
				else:submission="%s%s"%(submission,pygame.key.name(e.key))
				
			main.screen.fill(bg)
			main.screen.blit(self.question_surface,(x_lhs,y_top))
			
			s3=main.submission_font.render(submission,1,fg,bg)
			tlcx=main.W/2-main.submission_font.size(submission)[0]/2
			tlcy=y_top + self.question_surface.get_size()[0]
			main.screen.blit(s3,(tlcx,tlcy))
			try:main.flip()
			except Exception,e:print e
			
