import time,thread,os,random
from random import random
from thread import *
from tuxmathscrabble.Actor import *
from tuxmathscrabble.Environment import *


class Carousel:
	def __init__(self,theme):
		self.RUNNING=0
		self.PAUSED=0
		self.theme=theme
		self.actors=[]
		self.images={}
		self.config=None
		self.th=None

	def load_once(self,fname):
		if self.images.has_key(fname):
			rect=self.images[fname].get_rect()
			return self.images[fname].subsurface(rect)
		else:
			self.images[fname],rect=load_image(fname)
			return self.images[fname].subsurface(rect)

	def load_theme(self,theme,main):
		if theme==None:return
		themedir=os.path.join('tuxmathscrabble','Theme',theme,'background')
		infname=os.path.join(themedir,'config')
		if os.path.exists(infname):
			inf=open(infname)
			self.config=eval(inf.read())
			inf.close()
			
			self.backgrounds=[]#probably just one to conserve mem.
			self.seq_idx=0
			
			#open a representative img to get this number...
			bgname=os.path.join(themedir,self.config['maneuvers']['layer_0'][0]['img'])
			test=pygame.image.load(bgname)
			#print test.get_size()
			self.bgsize=test.get_size()[0]
			del test
		
			for idx in range(len(self.config['maneuvers'].keys())):
				#print indir
				key="layer_%d"%(idx)
				layer_actor=Actor(themedir,main.screen.get_size()[0],main.screen.get_size()[1],None,None,None,key,self,None)
				self.actors.append(layer_actor)
		
		
		#ALL THIS NEEDS SHRINKING AND PUT IN THEME CONFIG VIA MODULE
		frame_path=os.path.join('tuxmathscrabble','Theme',main.admin.cfg['theme'],'frame')
		frame=Actor(frame_path,main.W,main.H,None,None,None,'frame',self,None)
		self.add_actor(frame)
		
		layer_0=self.get_actor_by_maneuver_key('layer_0')#basically, envobjects have parent_actor's.
		layer_1=self.get_actor_by_maneuver_key('layer_1')
		layer_2=self.get_actor_by_maneuver_key('layer_2')
		layer_3=self.get_actor_by_maneuver_key('layer_3')
	
		actor0=Actor(os.path.join('tuxmathscrabble','Theme',main.admin.cfg['theme'],'lava01'),main.W,main.H,None,None,None,None,self,layer_0)
		self.add_actor(actor0)
		actor1=Actor(os.path.join('tuxmathscrabble','Theme',main.admin.cfg['theme'],'smoke01'),main.W,main.H,None,None,None,None,self,layer_0)
		self.add_actor(actor1)
		actor2=Actor(os.path.join('tuxmathscrabble','Theme',main.admin.cfg['theme'],'smoke02'),main.W,main.H,None,None,None,None,self,layer_0)
		self.add_actor(actor2)
		#actor4=Actor(os.path.join('tuxmathscrabble','Theme',main.admin.cfg['theme'],'ste'),main.W,main.H,None,None,None,None,self,layer_2)
		#self.add_actor(actor4)
		#rock01=Actor(os.path.join('tuxmathscrabble','Theme',main.admin.cfg['theme'],'rock01'),main.W,main.H,None,None,None,None,self,layer_1)
		#self.add_actor(rock01)

	def carousel_thread(self,callback,main):
		
		dx=main.admin.cfg['carousel_dx']
		carousel_timeout=main.admin.cfg['carousel_timeout']
		
		#for idx in range(len(self.actors)):
		#	print self.actors[idx].maneuvers[0]['key'],self.actors[idx].AMLAYER,self.actors[idx].z
		while self.RUNNING:
	 	  try:
			"""
			if random()*100.<1:
				dx=dx*-1
			self.sort_actors_by_z()
			time.sleep(carousel_timeout)
			
			main.screen.fill(main.admin.cfg['carousel_bgcolor'])
			for idx in range(0,len(self.actors)):
				#print 'rendering:',self.actors[idx].maneuvers[0]['key'],' where is frame???'
				try:self.actors[idx].render(main.screen,self.actors[0].tlcxy[0],dx)
				except Exception,e:print e,self.actors[idx].indir
			
			#print "dx:%03d\t tlcx:%5.2f"%(dx,self.actors[0].tlcxy[0])
			"""
			callback(main)
			
			
			
			
	  	  except Exception,e:
		  	print 'exception@carousel:',e	
		thread.exit()
		
	def start(self,callback,main):
		self.RUNNING=1
		self.th=start_new_thread(self.carousel_thread,(callback,main,))#either app.py or Game.py

		
	def sort_actors_by_z(self):
	  try:
		for idx in range(len(self.actors)):
			for jdx in range(len(self.actors)-1):
				if self.actors[jdx+1].z<self.actors[jdx].z:#bigger z -> render first (behind z=0)
					tmp=self.actors[jdx]
					self.actors[jdx]=self.actors[jdx+1]
					self.actors[jdx+1]=tmp
	  except Exception,e:print e	
			
	def add_actor(self,actor):
		if actor==None:return
		self.actors.append(actor)
		self.sort_actors_by_z()
	
	def clear(self):
		
		DND=[]
		
		#print 'carousel.clear'
		for idx in range(len(self.actors)-1,-1,-1):
			#print 'idx=',idx,'/',len(self.actors)
			xdelete=True
			if self.actors[idx].z==0:continue
			#print 'considering: ',self.actors[idx].actor_name,self.actors[idx]
			for key in DND:
				if self.actors[idx].config['preferences']['name']==key:
					xdelete=False
					#print 'marking False for actor_name=',self.actors[idx].actor_name
			if xdelete==True:
				#print 'deleting:',self.actors[idx].actor_name
				self.actors.pop(idx)
		
	def get_actor_by_maneuver_key(self,maneuver_key):#this is FRAGILE! (would like to use ANY maneuver name; now we can't b/c this)
		for actor in self.actors:
			if actor.maneuvers[0]['key']==maneuver_key:return actor
		return None

	def stop(self):
		self.RUNNING=0
		
