## \file app.py
## \brief Manages both wx and pygame toolkits

from wxPython.wx import *
from wxPython.html import *
from wxPython.grid import *
from wxPython.lib.imagebrowser import *

import pygame
from pygame.locals import *

from tuxmathscrabble.Login import *
from tuxmathscrabble.Admin import *
#from tuxmathscrabble.Game import *
from tuxmathscrabble.Carousel import *
from tuxmathscrabble.old.Projectile import *
from tuxmathscrabble.Environment import *
from tuxmathscrabble.old.tuxmathscrabble import *

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'
pygame.init()


# app class
class app(wxApp):
	"""\brief This is where we start.
	"""
	def __init__(self):
		wxApp.__init__(self, 0)
		self.name='app'
	def OnInit(self):
		wxInitAllImageHandlers()
		win=App()
		return true
	
	def OnButton(self, evt):
		self.frame.Close(true)

class App(wxFrame):
	def OnInit(self):
		wxInitAllImageHandlers()
		return true

	def __init__(self):
		wxFrame.__init__(self, None, -1, "", size=(1,1))

		theLogin=Login(self)
		self.admin=Admin(self)
		self.get_from_admin_config()
		
		self.carousel=None
		self.hs,self.highscores=self.refresh_highscores()
		
		bkg = pygame.Surface(self.screen.get_size())
		self.bkg=bkg.convert()
		self.bkg.fill((0,0,0))
		pygame.display.set_caption("Software@theLimit")
		self.screen.blit(self.bkg,(0,0))
		
		self.parent=None
		self.ufield=None
		self.pfield=None
		self.user=None
		self.adcount=50
		self.ad=""
		
		self.Centre(wxBOTH)

		count=0
		while True:
			rval=self.gocarousel()
			username=None
			fail_count=0
			while username==None:
				username=theLogin.login()
				if username=='admin':self.goadmin()
				elif username=='cancel':break
				elif username != None:self.gogame(username)
				else:fail_count+=1
				if fail_count>=3:break
				
				
		sys.exit()
	
	def get_from_admin_config(self):
		self.W=self.admin.cfg['W']
		self.H=self.admin.cfg['H']
		self.font=pygame.font.Font(self.admin.cfg['default_font'],self.admin.cfg['appname_fontsize'])
		self.appname_font=pygame.font.Font(self.admin.cfg['default_font'],self.admin.cfg['appname_fontsize'])
		self.results_font=pygame.font.Font(self.admin.cfg['default_font'],self.admin.cfg['results_fontsize'])
		self.submission_font=pygame.font.Font(self.admin.cfg['default_font'],self.admin.cfg['submission_fontsize'])
		self.hud_font=self.results_font
		self.screen = pygame.display.set_mode((self.W,self.H))
		self.fwoverlay=FWOverlay(self.screen,self.admin.cfg['launch_interval'])

	def flip(self):
		pygame.display.flip()
	
	def gocarousel(self):
		#***************************************************
		#load all user configs and determine high score,name
		#***************************************************
		
		self.carousel=Carousel(self.admin.cfg['theme'])
		#self.carousel.load_theme(self.admin.cfg['theme'],self)
			
		bkg = pygame.Surface(self.screen.get_size())
		bkg=bkg.convert()
		bkg.fill((100,0,100))
		pygame.display.set_caption("Software@theLimit")
		self.screen.blit(bkg,(0,0))
		
		self.carousel.clear()
		self.carousel.start(self.callback,self)
		RUNNING=True
		while RUNNING:
				evt=pygame.event.wait()
				if evt.type == KEYDOWN:
					if evt.key==K_F12:
						display_surface=pygame.display.get_surface()
						pygame.image.save(display_surface,os.path.join(os.environ['HOME'],'screenshot.bmp'))
					
					elif evt.type == KEYDOWN and evt.key == K_ESCAPE:
						RUNNING=False
						self.carousel.stop()
						time.sleep(1)
						sys.exit()
					else:
						RUNNING=False
						self.carousel.stop()
						
				
		return 0

	def callback(self,arg):
		img_w=self.screen.get_size()[0]
		img_h=self.screen.get_size()[1]
		
		self.screen.blit(self.bkg,(0,0))
		self.fwoverlay.tick()
		
		title=self.admin.cfg['Application Name']
		rendered_size=self.font.size(title)
		x_lhs=self.W/2-rendered_size[0]/2
		self.screen.blit(self.appname_font.render(title,1,self.admin.cfg['appname_fontcolor']),(x_lhs,self.admin.cfg['ytop_header']))
		
		"""
		#advertisement problem:
		self.adcount=self.adcount+1
		if self.adcount>=100:
			self.adcount=0
			a=int(2+random()*10)
			b=int(2+random()*10)
			self.ad="%d x %d = %d"%(a,b,a*b)
		
		font_surf=self.results_font.render(self.ad,1,self.admin.cfg['fgcolor'])
		fhw=font_surf.get_size()[0]/2.
		self.screen.blit(font_surf,(img_w/2.-fhw,self.admin.cfg['ytop_advertisement']))
		"""
		
		#high score:
		hstxt="%s is %s -> %s!"%('HighScore',self.hs[0],self.hs[1])
		font_surf=self.results_font.render(hstxt,1,self.admin.cfg['fgcolor'])
		fhw=font_surf.get_size()[0]/2.
		self.screen.blit(font_surf,(img_w/2.-fhw,self.admin.cfg['ytop_highscore']))
		
		self.flip()
		
		
	def goadmin(self):
		rval=self.admin.ShowModal()
		self.hs,self.highscores=self.refresh_highscores()
		self.admin.reload_config()
		self.get_from_admin_config()
		
	def gogame(self,name):
		DEBUG=0
		#game=Game(self)
		#rval=game.ShowModal(name)
		try:
			for sitepkgdir in sys.path:
				if sitepkgdir[-13:]=='site-packages':break
		except:pass
		tmsdir=os.path.join(sitepkgdir,'tuxmathscrabble','old')
		themedir=os.path.join(tmsdir,'themes')
		themes=[]
		for d in os.listdir(themedir):
			if DEBUG:print d
			if os.path.isdir(os.path.join(themedir,d)):
				themes.append(d)
		if DEBUG:print 'available themes: ',themes
		
		LEVEL=1
		theme_name=None
		try:
			theme_name=themes[0]
			if DEBUG:print 'using themes[0]=',theme_name
		except:theme_name='default'
		while LEVEL>0:
			t=TuxMathScrabble(themes,theme_name,LEVEL,self.admin.scoring)
			#t.startup()
			score,theme_name,LEVEL=t.play()
			
			user_infname=os.path.join(userdir,name,'config')
			user_oufname=user_infname
			user_config=self.load_user_config(user_infname)
			try:
				if score>eval(user_config['high_score']):
					user_config['high_score']=`score`
					self.save_user_config(user_oufname,user_config)
					self.hs,self.refresh_highscores()
					#print 'self.hs=',self.hs
			except Exception,e:print e
	
	def refresh_highscores(self):
		self.hs=('Nobody','0')
		self.highscores=[]
		
		for name in os.listdir(userdir):
			infname=os.path.join(userdir,name,'config')
			#print infname
			if not os.path.exists(infname):continue
			config=self.load_user_config(infname)
			#print eval(config['high_score'])
			#print eval(self.hs[1])
			self.highscores.append((name,config['high_score']))
			if eval(config['high_score'])>eval(self.hs[1]):self.hs=(name,config['high_score'])
		
		#print 'hs=',self.hs
		return self.hs,self.highscores
	
	def load_user_config(self,user_infname):
		inf=open(user_infname)
		user_config=eval(inf.read())
		return user_config
						
	def save_user_config(self,oufname,config):
		ouf=open(oufname,'w')
		ouf.write("{\n")
		for key in config.keys():
			line="\t'%s':%s,\n"%(key,`config[key]`)
			ouf.write(line)
		ouf.write("}")
		ouf.close()
			
		
			
