#!/usr/bin/python

#import PIL
#from PIL import Image,ImageDraw
from math import *
import sys,os,time,copy
from os.path import join
from random import random
import pygame
from pygame.locals import *


class Projectile(pygame.sprite.Sprite):
	def __init__(self,pkg):
		
		#tblow,radius,x0,y0,vx0,vy0,ay,r,g,b,tl
		#tblow,dtblow,radius,x0,dx0,y0,dy0,vx0,dvx0,vy0,dvy0,ay,r,dr,g,dg,b,db,tl,dtl
		#   0     1      2    3   4  5  6    7   8    9   10  11 1213 1415 1617  1819
		pygame.sprite.Sprite.__init__(self)
		self.pkg=pkg
		self.tblow=pkg[0]
		self.dtblow=pkg[1]
		self.radius=pkg[2]
		self.x=pkg[3]
		self.y=pkg[5]
		self.x0=pkg[3]
		self.y0=pkg[5]
		self.vx=pkg[7]
		self.vy=pkg[9]
		self.vx0=pkg[7]
		self.vy0=pkg[9]
		self.ay=pkg[11]
		self.r=pkg[12]
		self.g=pkg[14]
		self.b=pkg[16]
		self.tail_length=pkg[18]
		self.tail=[]
		self.pyld=None
		self.image=pygame.Surface((int(self.radius),int(self.radius)))
		self.image.fill((self.r,self.g,self.b))
		self.rect=pygame.Rect(self.x0,self.y0,self.radius,self.radius)
		
	def killall(self):
		for sp in self.pyld.sprites():
			sp.killall()
			sp.kill()
		
	def update(self,sf,t,dt,group):
		tel=t-self.tblow
		c=self.image.get_at(self.image.get_rect().center)
		self.image.fill((c[0]*sf,c[1]*sf,c[2]*sf))
		self.r=c[0]
		self.g=c[1]
		self.b=c[2]
		self.vx=self.vx0#+self.ax*tel
		self.vy=self.vy0+self.ay*tel
		dx=self.vx*dt
		dy=self.vy*dt
		self.rect=self.rect.move(dx,dy)
		
		self.tail.insert(0,self.rect.center)
		if len(self.tail)>self.tail_length:self.tail.pop()
		
		for sp in self.pyld.sprites():
			if t>sp.tblow:
				sp.rect=pygame.Rect(self.rect[0],self.rect[1],sp.rect[2],sp.rect[3])
				sp.vx0=self.vx+sp.vx0
				sp.vy0=self.vy+sp.vy0
				sp.add(group)
				sp.remove(self.pyld)
				
		

def get_rand(x,dx):
	rval=x+dx*(1.-2.*random())
	return rval

class FWOverlay:
	def __init__(self,screen,launch_interval):
		self.screen=screen
		self.w=self.screen.get_size()[0]
		self.h=self.screen.get_size()[1]
		self.sf=.96
		self.pi=acos(-1.)
		self.launch_interval=launch_interval
		self.t=0.
		self.dt=1.
		self.projectiles=projectiles=pygame.sprite.RenderClear()
		self.pkgs=self.mkpkgs()
		self.ntypes=len(self.pkgs)
		
	def getn(self,n,pkgi):
		pi=self.pi
		group=pygame.sprite.RenderClear()
		for idx in range(int(n)):
			#tblow,dtblow,r,x0,dx0,y0,dy0,vx0,dvx0,vy0,dvy0,ay, r,dr, g,dg, b,db, tl,dtl, n, dn, ringflag
			#  0     1    2 3  4   5   6   7   8   9    10  11 12 13  14 15 16 17 18 19   20 21     22
			pkg=[]
			
			if n==1:theta=get_rand(pi/2,pi/4)
			else:theta=random()*2*pi
			
			pkg.append(self.t+get_rand(pkgi[0],pkgi[1]))#NOTE: self.t+
			pkg.append(pkgi[1])
			pkg.append(pkgi[2])#radius
			pkg.append(get_rand(pkgi[3],pkgi[4]))
			pkg.append(None)
			pkg.append(get_rand(pkgi[5],pkgi[6]))
			pkg.append(None)
			if pkgi[22]:pkg.append(pkgi[7]+pkgi[8]*cos(theta))
			else:pkg.append(pkgi[7]+pkgi[8]*cos(theta)*random())
			pkg.append(None)
			if pkgi[22]:pkg.append(pkgi[9]+pkgi[10]*sin(theta))
			else:pkg.append(pkgi[9]+pkgi[10]*sin(theta)*random())
			pkg.append(None)
			pkg.append(pkgi[11])#ay
			pkg.append(get_rand(pkgi[12],pkgi[13]))
			pkg.append(None)
			pkg.append(get_rand(pkgi[14],pkgi[15]))
			pkg.append(None)
			pkg.append(get_rand(pkgi[16],pkgi[17]))
			pkg.append(None)
			pkg.append(get_rand(pkgi[18],pkgi[19]))
			pkg.append(None)
			
			p=Projectile(pkg)
			p.pyld=pygame.sprite.RenderClear()
			group.add(p)
		
		return group
		
	def build(self,pkg):
		w=self.w
		h=self.h
		sf=self.sf
		n=get_rand(pkg[0][20],pkg[0][21])
		sp0=self.getn(n,pkg[0]).sprites()[0]
		
		if len(pkg)>1:
			n=get_rand(pkg[1][20],pkg[1][21])
			sp0.pyld=self.getn(n,pkg[1])
			if len(pkg)>2:
				for sp1 in sp0.pyld.sprites():
					n=get_rand(pkg[2][20],pkg[2][21])
					sp1.pyld=self.getn(n,pkg[2])
					for sp in sp1.pyld.sprites():
						if sp.dtblow==0:sp.tblow=sp1.tblow#sets to parent time for boom-boom
						
					if len(pkg)>3:
						for sp2 in sp1.pyld.sprites():
							n=get_rand(pkg[3][20],pkg[3][21])
							sp2.pyld=self.getn(10,pkg[3])
							for sp in sp2.pyld.sprites():
								if sp.dtblow==0:sp.tblow=sp2.tblow#sets to parent time for boom-boom
				
		return sp0
	
	def getpkg(self,arg):
		if type(arg)==int:
			return self.pkgs[arg]
		else:
			for pkg in self.pkgs:
				if pkg.keys()[0]==arg:return pkg
			
			
		
	def tick(self):
		w=self.w
		h=self.h
		
		if fmod(self.t,self.launch_interval)==0:
			for idx in range(int(100*random())):random()
			ftype=int(floor(self.ntypes*random()))
			pkg=self.getpkg(ftype)
			#pkg=self.getpkg("TEST")
			pkgname=pkg.keys()[0]
			#print "Launching: %s"%(pkgname)
			p=self.build(pkg[pkgname])
			self.projectiles.add(p)
			
		self.projectiles.update(self.sf,self.t,self.dt,self.projectiles)
		self.projectiles.draw(self.screen)
		
		for sp in self.projectiles.sprites():
			color=sp.image.get_at((0,0))
			if (color[0]+color[1]+color[2])<30:sp.killall();sp.kill()#this should be a param in config (color cutoff for sprite removal)
			elif sp.rect[0]<0:sp.killall();sp.kill()
			elif sp.rect[0]>w or sp.rect[1]>h:sp.killall();sp.kill()
		
			if len(sp.tail)<1:continue
			for tidx in range(len(sp.tail)-1):
				x0=sp.tail[tidx][0];
				y0=sp.tail[tidx][1];
				x1=sp.tail[tidx+1][0];
				y1=sp.tail[tidx+1][1];
				pygame.draw.aaline(self.screen,(sp.r/(tidx+1),sp.g/(tidx+1),sp.b/(tidx+1)),(x0,y0),(x1,y1))
			
		self.t=self.t+1

	def mkpkgs(self):
		pkgs=[]
		ay=+.2
		x0=self.w/2
		dx0=self.w/3
		y0=self.h
		dy0=0.
		vx0=0.
		dvx0=5.
		vy0=-18#.*self.h/768.
		dvy0=3.
		dr=0
		dg=0
		db=0
		n=1
		dn=0
		ringflag=1
		
		desc='TEMPLATE'
		package=[
			[00,00,04,x0,dx0, y0,dy0,vx0, dvx0,vy0,dvy0,ay, 255,000, 100,000, 000,000, 04,00, 01,00, True ],
			[35,00,03,x0,dx0, y0,dy0,000.,007.,00.,007.,ay, 250,000, 000,000, 255,000, 14,10, 50,10, True ],
			#[65,05,02,x0,dx0, y0,dy0,000.,003.,00.,001.,ay, 250,000, 255,000, 255,000, 04,00, 10,00, False],
		]
		#pkgs.append({desc:package})
		
	   	desc='RED SUPERNOVA'
		package=[
			[00,00,03,x0,dx0, y0,dy0,vx0, dvx0,vy0,dvy0,ay, 255,000, 000,000, 000,000, 10,00, 01,00, True ],
			[25,00,02,x0,dx0, y0,dy0,000.,005.,00.,005.,ay, 250,000, 000,000, 000,000, 10,05, 20,05, True ],
			[30,01,02,x0,dx0, y0,dy0,000.,002.,00.,002.,ay, 250,000, 255,000, 255,000, 04,00, 02,01, True ],
			[45,01,01,x0,dx0, y0,dy0,000.,005.,00.,005.,ay, 000,000, 000,000, 200,055, 03,00, 02,01, False ],
		]
		pkgs.append({desc:package})
		
		desc='PURPLE RING WITH WHITE FRINGE'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,       g,dg,   b,db, tl, dtl, n,dn,ring
			   [	   00,     0,     4, x0,dx0, y0,dy0, vx0, dvx0, vy0,dvy0,  ay, 255, dr, 100, dg, 000, db,  4,   0,  n,dn,True],
			   [	   35,     0,     3, x0,dx0, y0,dy0,  0.,  07.,  0.,  07., ay, 250,000, 000,000, 255,000,  4,   0, 50,10,True],
			   [	   65,     5,     2, x0,dx0, y0,dy0,  0.,  03.,  0.,  01., ay, 250,000, 255,000, 255,000,  4,   0, 10,00,False],
			]
		pkgs.append({desc:package})

		desc='WIDE MULTI COLORED ASSORTMENT'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0,  vy0, dvy0,      ay,   r, dr,   g, dg,   b, db, tl,  dtl,  n,dn,ring
			   [	   00,    00,     4, x0,dx0, y0,dy0, vx0,dvx0,  vy0, dvy0, ay, 255, dr, 100, dg, 000, db, 03,   02,  n,dn,True],
			   [	   20,    00,     3, x0,dx0, y0,dy0, 00.,  10., 00.,  02., ay, 255,000, 255,000, 000,000, 05,   00, 10,05,False],
			   [	   40,    10,     2, x0,dx0, y0,dy0, 00.,  04., 00.,  04., ay, 155,100, 155,100, 155,100, 10,   00, 10,05,True],
			]
		pkgs.append({desc:package})

		desc='WHITE ARCHING EFFECT'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,       g,dg,   b,db, tl, dtl, n,dn,ring
			   [	   00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0, dvy0, ay, 255, dr, 100, dg, 000, db, 10,   2, n,dn,True],
			   [	   35,     5,     3, x0,dx0, y0,dy0,  0.,   5.,  0.,   0., ay, 250,000, 255,000, 255,000, 10,  5, 50,10,False],
			]
		pkgs.append({desc:package})
		
		desc='DOUBLE BIG RANDOM-COLORED'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,    10.,     1, x0,dx0, y0,dy0,  0,   4,    0,   4, ay, 255,000, 255,000, 255,000,002,  02, 2, 0,False],
			   [self.t+65,     0.,     1, x0,dx0, y0,dy0,  0,  10,    0,  10, ay, 132,100, 132,100, 132,100,010,  10,50, 0,True],
			]
		pkgs.append({desc:package})
		
		desc='DOUBLE BIG WHITE'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,    10.,     1, x0,dx0, y0,dy0,  0,   4,    0,   4, ay, 255,000, 255,000, 255,000,002,  02, 2, 0,False],
			   [self.t+65,     0.,     1, x0,dx0, y0,dy0,  0,  10,    0,  10, ay, 255,000, 255,000, 255,000,010,  10,50, 0,True],
			]
		pkgs.append({desc:package})
		
		desc='FIRECRACKERS'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255, dr, 000, dg, 000,db, 03,   0, n,dn,True],
			   [self.t+20,     0,     1, x0,dx0, y0,dy0,  0,   04,   0,  04, ay, 255,  0, 255, dg, 255, 0, 03,   2,05,01,True],
			   [self.t+40,    10,     1, x0,dx0, y0,dy0,  0,   06,   0,  06, ay, 155,100, 155, 100,155,100,10,   3,15,05,False],
			]
		pkgs.append({desc:package})
		
		desc='SINGLE BIG WHITE'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g, dg,    b,db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255, dr, 255, dg,  255,db, 10,   0, n,dn,True],
			   [self.t+25,     0,     1, x0,dx0, y0,dy0,   0,  10,   0,  10, ay, 255,  0, 255, dg,  255, 0, 10,   0,50,dn,True],
			]
		pkgs.append({desc:package})
		
		desc='SINGLE BIG GREEN'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g, dg,    b,db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 000, dr, 255, dg,  000,db, 10,   0, n,dn,True],
			   [self.t+25,     0,     1, x0,dx0, y0,dy0,   0,  10,   0,  10, ay, 000, dr, 255, dg,  000,db, 10,   0,50,dn,True],
			]
		pkgs.append({desc:package})
		
		desc='SINGLE BIG BLUE WITH LAVENDER FRINGE'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g, dg,    b,db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 000, dr, 000, dg,  255,db, 10,   0, n,dn,True],
			   [self.t+10,     0,     3, x0,dx0, y0,dy0,   0,  02,   0,  02, ay, 000, dr, 000, dg,  255,db, 03,   0,15,dn,True],
			   [self.t+30,     1,     1, x0,dx0, y0,dy0,   0,  04,   0,  04, ay, 255, dr, 155,100,  255,db, 10,   5,10,05,True],
			]
		pkgs.append({desc:package})
			
		desc='SPILLING SHOWER'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+20,     0,     1, x0,dx0, y0,dy0,  0,   2,    0,   2, ay, 255,000, 255,000, 255,000,002,  02, 5, 2,False],
			   [self.t+45,     5,     1, x0,dx0, y0,dy0,  0,   1,    0,   1, ay, 132,123, 132,123, 132,123,010,  10,20, 0,True],
			]
		pkgs.append({desc:package})
		
		desc='BIG WHITE SPLASH'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,     2.,     4, x0,dx0, y0,dy0,  0,   10,    0, 10, ay, 255,000, 255,000, 255,000,012,  02, 100, 0,True],
			]
		pkgs.append({desc:package})
		
		desc='4X WHITE SUPERNOVA'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,    20.,     1, x0,dx0, y0,dy0,  0,   4,    0,   4, ay, 255,000, 255,000, 255,000,000,  00,04, 0,False],
			   [self.t+65,     0.,     3, x0,dx0, y0,dy0,  0,  10,    0,  10, ay, 255,000, 255,000, 255,000,010,  10,30, 0,True],
			]
		pkgs.append({desc:package})
		
		desc='SMALL FLAT OVAL BLUE-WHITE FRINGE'
		package=[
			#    tblow, dtblow, radius, x0,dx0, y0,dy0, vx0,dvx0,  vy0, dvy0,      ay,   r, dr,   g, dg,   b,  db, tl, dtl,  n,dn,ring
			   [	00,    00.,    03., x0,dx0, y0,dy0, vx0,dvx0,  vy0, dvy0, ay, 255,000, 000,000, 000,000,010, 00, n,dn,True],
			   [	20,    00.,    03., x0,dx0, y0,dy0,  00,  03,   00,   01, ay, 155,100, 000,000, 000,000,002, 02,40,20,True],
			   [	40,    08.,    01., x0,dx0, y0,dy0,  00,  01,   00,   01, ay, 200,000, 200,000, 255,000,004, 00,05,00,True],
			]
		pkgs.append({desc:package})

		desc='TEST'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,     5.,     4, x0,dx0, y0,dy0,  0,   10,    0, 10, ay, 055,000, 200,055, 000,000,012,  02, 002, 0,True],
			   [self.t+40,     0.,     4, x0,dx0, y0,dy0,  0,   10,    0, 10, ay, 055,000, 200,055, 000,000,012,  02, 100, 0,True],
			]
		pkgs.append({desc:package})
		desc='BRIGHT YELLOW GREEN SPLASH'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,     2.,     4, x0,dx0, y0,dy0,  0,   10,    0, 10, ay, 155,100, 155,100, 000,000,012,  02, 100, 0,True],
			]
		pkgs.append({desc:package})

		desc='MULTI BLUE SPLASH'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,  db, tl, dtl, n,dn,ring
			   [self.t+00,     0.,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0, ay, 255,000, 000,000, 000,000,010,  00, n,dn,True],
			   [self.t+30,     2.,     4, x0,dx0, y0,dy0,  0,   10,    0, 10, ay, 100,100, 155,100, 190,000,012,  02, 100, 0,True],
			]
		pkgs.append({desc:package})

		desc='YELLOW ARCHING EFFECT'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,   g,dg,   b,db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0, dvy0, ay, 255, dr, 000, dg, 000, db, 10,   0, n,dn,True],
			   [self.t+35,    05,     1, x0,dx0, y0,dy0,  0.,   5.,  0.,   0., ay, 250,000, 200,055, 000,000, 10,   0,125,0,False],
			]
		pkgs.append({desc:package})
		
		desc='WHITE ARCHING EFFECT'
		package=[
			#       tblow,dtblow,radius, x0,dx0, y0,dy0, vx0,dvx0, vy0,dvy0,      ay,   r, dr,       g,dg,   b,db, tl, dtl, n,dn,ring
			   [self.t+00,     0,     4, x0,dx0, y0,dy0, vx0,dvx0, vy0, dvy0, ay, 255, dr, 100, dg, 000, db, 10,   2, n,dn,True],
			   [self.t+35,     5,     3, x0,dx0, y0,dy0,  0.,   5.,  0.,   0., ay, 250,000, 255,000, 255,000, 10,  5, 50,10,False],
			]
		pkgs.append({desc:package})
		
		return pkgs
